#!/bin/sh
#
# memory-larrd.sh - larrd module template for collecting memory data gathered by BBDISPLAY 

# INSTRUCTIONS
# Put this file and memory-graph.sh in your larrd directory, and bb-memory in bbrun.sh
# Linux/Unix/Solaris graphs won't be collected without the bb-memory.sh script, but since
# the NT client already posts this in the .cpu logs it will work for them without it.
# You also need to add memory to DATALIST in larrd.conf in order for the test to show up on the
# status display.
# You can download bb-memory.sh from ftp://ftp.deadcat.net/pub/BB/ext/bb-memory.sh
#
# version 1.05 
#
# 8.7.2000
# Ingolfur Arnar Stangeland 
# ingolfur@ejs.is
#  
# version 1.06 
# Craig Cook
#    Fixed typo
#     if [ $STATUS -eq 1]
#     to:
#     if [ $STATUS -eq 1 ]
#

####  HACK JG  ^ replaced by perl conf file...
#RRDDIR=/usr/local/rrdtool/
#RRDTOOL=${RRDDIR}bin/rrdtool
#BBRRDS=${BBHOME}/rrd
#GRAPHS=${BBHOME}/www/graphs

########################################
# NOTES:
# This has been tested with BB 1.4f and 1.4h2
#
# If you are using BB 1.4h2 or above you may need to swap $5 with $4 in the test for real/swap
# memory (in $AWK '{print $5}'). 
# If you fail to get graphs from NT boxes, try switching $16 for $17 in the NT awk test, 
# if timezone GST/EST etc. is being reported.
########################################

# set -x

##################################
# Start of script
##################################

if test ! "$BBHOME"
then
        echo "$0: BBHOME is not set"
        exit 1
fi

if test ! "$BBRRDS"
then
	echo "$0: BBRRDS is not set"
	exit 1
fi

if test ! -d "$BBHOME"
then
        echo "$0: BBHOME is invalid"
        exit 1
fi

##
# real work begins here
##

# go to the logs area for simplication of the list
cd $BBLOGS

# go to the logs area and see what data we can gather 

for log in `ls *.memory`
do
	# you need three things to collect data
	# RRD - an RRD
	# TS=oNnet-grapht>p (in epoch)
	# VALUEoNnvalue of data (could be multiple values, see disk-larrd.sh for ext>ple)	

	# getting RRD
	HOST=`echo $log | $SED 's/\.memory//'`
	# pearcec added this line to match how larrd likes the rrds 11/9/2000
	# I need to fix this
	#HOST=`echo $HOST | $SED 's/,/\.//'`
	RRD=$BBRRDS/$HOST.memory.real.rrd

	# if it doesn't exist, make it 
	if [ ! -f $RRD ]
	then
		# $RRAS is defined in larrd.conf
		$RRDTOOL create $RRD DS:realmempct:GAUGE:600:0:U $RRAS


		if [ $STATUS -eq "1" ]
		then
			echo "$0: STATUS  did not find $RRD, created."
		fi
	fi

	# RRD acquisition complete, proceed to TS	

	# i am lazy right now and just using current -gra
	# getting epoch from a file -grapht>p is a pain 
	# so the -grapht>p is from when the data is gathered
	# not when it actually happened, ugh
	TS=N
	# TS=acquisition co>plete, proceed to VALUE
	 
	# now lets get the data 
	# look through the file and get what you want
	#  e.g. load average
	 VALUE=`$HEAD -3 $log | $EGREP 'Physical|Real' |$AWK '{print $5}' |$SED 's/%//g'` 
	 #VALUE=`$HEAD -3 $log | $GREP Real |$AWK '{print $5}' |$SED 's/%//g'` 
	# VALUEoacquired, do the job

	if [ $DEBUG -eq 1 ]
	then
		echo "$0: DEBUG $RRDTOOL update $RRD $TS:$VALUE"
	fi
	$RRDTOOL update $RRD $TS:$VALUE


RRD=$BBRRDS/$HOST.memory.swap.rrd


        # if it doesn't exist, make it
        if [ ! -f $RRD ]
        then
                # $RRAS is defined in larrd.conf
                $RRDTOOL create $RRD DS:realmempct:GAUGE:600:0:U $RRAS


		if [ $STATUS -eq 1 ]
		then
	                echo "$0: STATUS did not find $RRD, created."
		fi
        fi

        # RRD acquisition co>plete, proceed to TS

        # i am lazy right now and just using current -gra
        # getting epoch from a file -grapht>p is a pain
        # so the -grapht>p is from when the data is gathered
        # not when it actually happened, ugh
        TS=N
        # TS=acquisition complete, proceed to VALUE

        # now lets get the data
        # look through the file and get what you want
        #  e.g. load average
         VALUE=`$HEAD -5 $log | $EGREP 'Swap|Page' |$AWK '{print $5}' |$SED 's/%//g'`
         #VALUE=`$HEAD -4 $log | $GREP Swap |$AWK '{print $5}' |$SED 's/%//g'`
        # VALUEoacquired, do the job

	if [ $DEBUG -eq 1 ]
	then
	        echo "$0: DEBUG $RRDTOOL update $RRD $TS:$VALUE"
	fi
        $RRDTOOL update $RRD $TS:$VALUE

done

	# NT logs the memory usage in .cpu

for log in `$GREP -c PhysicalMem *.cpu |$GREP cpu:1 |$SED 's/:1//'`
do
        # you need three things to collect data
        # RRD - an RRD
        # TS=oNnet-grapht>p (in epoch)
        # VALUEoNnvalue of data (could be multiple values, see disk-larrd.sh for ext>ple)

        # getting RRD
        HOST=`echo $log | $SED 's/\.cpu//'`
	# pearcec added this line to match how larrd likes the rrds 11/9/2000
	#HOST=`echo $HOST | $SED 's/,/\.//'`
        RRD=$BBRRDS/$HOST.memory.real.rrd

        # if it doesn't exist, make it
        if [ ! -f $RRD ]
        then
                # $RRAS is defined in larrd.conf
                $RRDTOOL create $RRD DS:realmempct:GAUGE:600:0:U $RRAS


		if [ $STATUS -eq 1 ]
		then
	                echo "$0: STATUS did not find $RRD, created."
		fi
        fi

        # RRD acquisition co>plete, proceed to TS

        # i am lazy right now and just using current -gra
        # getting epoch from a file -grapht>p is a pain
        # so the -grapht>p is from when the data is gathered
        # not when it actually happened, ugh
        TS=N
        # TS=acquisition co>plete, proceed to VALUE

        # now lets get the data
        # look through the file and get what you want
        #  e.g. load average
         VALUE=`$HEAD -1 $log |$GREP PhysicalMem |$SED 's/days,//' | $AWK '{print $17}' |$SED 's/%//g' | $SED 's/(//' |$SED 's/)//' |$SED 's/MB/ /' |$AWK '{print $2}'`
         #VALUE=`$HEAD -1 $log |$GREP PhysicalMem |$SED 's/days,//' | $AWK '{print $16}' |$SED 's/%//g' | $SED 's/(//' |$SED 's/)//' |$SED 's/MB/ /' |$AWK '{print $2}'`
        # VALUEoacquired, do the job
	if [ $DEBUG -eq 1 ]
	then
		echo "$0: DEBUG $RRDTOOL update $RRD $TS:$VALUE"
	fi
        $RRDTOOL update $RRD $TS:$VALUE


done

##############################################
# end of script
##############################################

# pearcec commented this out 11/9/2000
#/export/local/bigbrother/larrd-0.40/memory-graph.sh
