#!/usr/local/bin/perl
#
# $Id: WebApp-larrd.pl,v 1.2 2004/02/24 20:30:11 cncook Exp $
#
# webapp-larrd.pl - larrd module for collecting url response times
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks
# Now uses LARRD.pm


@web_array = ("http","WebApp");

my @ds = ("DS:sec:GAUGE:600:0:U",
       );

my $reference_to_rrd_data_structure = \@ds;

my $DEBUG = 0;
$DEBUG = 1 if $ENV{'DEBUG'};
my $WARN = 1 if $ENV{'WARN'};

if ($DEBUG) {
  $WARN = 1;
  $ENV{'BBHOME'}="/usr/local/bb";
  $ENV{'BBVAR'}="/usr/local/bbvar";
  $ENV{'BBLOGS'}="/usr/local/bbvar/logs";
  $ENV{'BBRRDS'}="$ENV{'BBVAR'}/rrd";
  use lib "/usr/local/rrdtool/lib/perl/";
  use lib "/usr/local/larrd/lib/LARRD";
}

use lib $ENV{'RRDPM'};
use RRDs;

use lib $ENV{'LARRDPM'};
use LARRD;

my $larrd = new LARRD;

##################################
# Start of script
##################################

$larrd->check_larrd_env;

##
# real work begins here
##


# Now we will do http since it have have several urls we break up the
# rrds into seperate files for a 1 to 1 relationship.  This allows
# easy additions of urls.

$filenames_ref = $larrd->get_bb_log_filenames($DEBUG);

foreach $ds (@web_array) { 

  $hash_ref_for_hosts = $larrd->read_bb_logs($DEBUG,$ds,$filenames_ref);

  while ( ($host,$log_filename) = each %$hash_ref_for_hosts ) {

    my $sec = "";
    my $urlcount = 0;

    print "$0 : DEBUG host=$host, log=$log_filename\n" if ($DEBUG);

    $log_time = $larrd->get_log_time($DEBUG,$log_filename);

    $reference_to_log_data = $larrd->get_info_from_log($DEBUG,$log_filename);

    if($$reference_to_log_data[0] !~ /^(green|yellow|red)\s+/) {
            print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($WARN);
            next;
    }

    # Now lets process the data

    my $data_value = &process_log($DEBUG,$reference_to_log_data);

    #  if ($data_value ne "") {

       # If we are looking at a log with no larrdable data
       # do not create the rrd and in turn the graph
       # It makes sense this way.

    #     $larrd->update_rrd($DEBUG,$RRD,$log_time,$data_value,$reference_to_rrd_data_structure);

    #  } # end if ($data_value ne "") {


  } # end while ( ($host,$log_filename) = each %$hash_ref_for_hosts ) {

} # end foreach $ds (@web_array) {


sub process_log ($$) {

my $DEBUG = shift;
my $log_data_ref = shift;

  print "$0: DEBUG in process_log\n" if $DEBUG;

        foreach $line (@$reference_to_log_data) {

                print "line: $line\n" if $DEBUG;
                if($line =~ /^&/) {
                  # eg &green http://www.domain.com
                        ($dummy,$url) = split " ",$line,3;
                        $url =~ s/http\:\/\///g;
                        $url =~ s/\//\,/g;
                        $urlcount++;
                print "url: $url\n" if $DEBUG;
                }

                if($line =~ /Seconds/) {
                  # eg Seconds 1.1
                        ($dummy,$sec) = split " ",$line,3;
                        $http{$url}=$sec;
                  print "seconds: $sec\n" if $DEBUG;
                }
        }

        if ($urlcount > 0) {
        # with the hash in place we will roll our own rrds
          foreach $url (keys %http) {

            $RRD="$ENV{'BBRRDS'}/$host.tcp.$ds.$url.rrd";

            $data_value = $http{$url};

            $larrd->update_rrd($DEBUG,$RRD,$log_time,$data_value,$reference_to_rrd_data_structure);

            # Store the raw data for further analysis

            open(RAWLOG, '>>/usr/local/bb/bbvar/rawdata/'.$host."-".$url);
            printf(RAWLOG "%lu,%5.2f\n", ($log_time, $data_value));
            close(RAWLOG);

          } #end foreach $url

          # Very important
          undef %http;

        } # end if ($urlcount > 0) {

}

##############################################
# end of script
##############################################
