#!/usr/local/bin/perl
#
# imap2-larrd.pl - larrd module for collecting IMAP stats
#
# Modified from the la-larrd.pl module.
#
# Written by Craig Cook Dec 2002
#
# Do whatever you want with it, just don't sell it!
# I take no liability for it, use at your own risk!

# 27 Jun 2003   Craig Cook
# Changed status check to look for colour status only at start of line

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

$test = "imap2" ;

@ds = ("DS:imap2:GAUGE:600:0:U"
      );

use lib $ENV{'RRDPM'};
#use lib "/usr/local/rrdtool/lib/perl/";
use RRDs;

my $larrd = new LARRD;

##################################
# Start of script
##################################

$larrd->check_larrd_env;


##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBLOGS'}";

# Glob the imap2 logs
LOG: while ( defined ($log = <*.$test>) ) {

  $host=$log;
  # create some handy vars
  $host =~ s/\.$test//;
  $host =~ s/\,/\./g;

  ($ctime) = (stat($log))[10];

  # Slurp up the log into an array
  open(LOG,"$log");
  @log=<LOG>;
  close(LOG);

  if($log[0] !~ /^green\s+|^yellow\s+|^red\s+/) {
    print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n"
    if ($ENV{'WARN'});
      next LOG;
     }

    # Now lets process the list
    foreach $line (@log) {
      next if ($line =~/^(^green\s+|^yellow\s+|^red\s+)/);
      next unless ($line =~ /Total Time: (\d+\.\d+) seconds/);
      $imap_response_time = $1;
    }

    # RRD for imap2
    $RRD="$ENV{'BBRRDS'}/$host.$test.rrd";
    # if it doesn't exist, make it
    if ( not -f $RRD ) {

      # RRAS defined in larrd.pl
      @rras = split " ",$ENV{'RRAS'};
      RRDs::create($RRD,@ds,@rras);
      $ERR=RRDs::error;
      if($ERR) {
        print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
        next;
      }

      $ctime="N";
      print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
    }

    RRDs::update("$RRD","$ctime:$imap_response_time");
    $ERR=RRDs::error;
    if($ERR) {
      print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
  }
}

##############################################
# end of script
##############################################
