package LARRD;

use 5.006;
use strict;
use warnings;


BEGIN {
    #use Exporter ();
    require Exporter;
    our ($VERSION, @ISA, @EXPORT, @EXPORT_OK, %EXPORT_TAGS);

    $VERSION = sprintf "%d.%03d", q$Revision: 1.1 $ =~ /: (\d+)\.(\d+)/;
    #$VERSION = do { my @r = (q$Revision: 2.21 $ =~ /\d+/g); sprintf "%d."."%02d" x $#r, @r }
    @ISA = qw(Exporter);

    @EXPORT = qw(
      &verbose
    );

    # Items to export into callers namespace by default. Note: do not export
    # names by default without a very good reason. Use EXPORT_OK instead.
    # Do not simply export all your public functions/methods/constants.

    # This allows declaration	use LARRD ':all';
    # If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
    # will save memory.
    #%EXPORT_TAGS = ( 'all' => [ qw(
	
    #) ] );
    %EXPORT_TAGS = ( );     # eg: TAG => [ qw!name1 name2! ],

    # your exported package globals go here,
    # as well as any optionally exported functions
    @EXPORT_OK = ();
}

our @EXPORT_OK;
#our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );


sub new {
  my $package = shift;
  return bless({}, $package);
}

sub verbose {
  my $self = shift;
  if (@_) {
    $self->{'verbose'} = shift;
  }
  return $self->{'verbose'};
}

sub check_larrd_env {

  if( not $ENV{'BBHOME'} ) {
        print "$0: BBHOME is not set\n";
        exit(1);
  }

  if( not -d $ENV{'BBHOME'} ) {
        print "$0: BBHOME is invalid\n";
        exit(1);
  }

  if( not -d $ENV{'BBRRDS'} ) {
        print "$0: BBRRDS is not set\n";
        exit(1);
  }

  return;
}

sub get_bb_log_filenames ($$) {

my ($dummy, $DEBUG) = @_;
my @filenames;
my $filenames_ref;

  opendir(DIR, "$ENV{'BBLOGS'}") or die "$0: $!";

  print "$0: DEBUG bb log dir opened\n" if ($DEBUG);

  @filenames = readdir(DIR) or die "Unable to read current dir:$!\n";

  closedir(DIR);

  $filenames_ref = \@filenames;
  return ($filenames_ref);

}

sub get_bb_data_log_filenames ($$) {

my ($dummy, $DEBUG) = @_;
my @filenames;
my $filenames_ref;

  opendir(DIR, "$ENV{'BBVAR'}/data") or die "$0: $!";

  print "$0: DEBUG bb log dir opened\n" if ($DEBUG);

  @filenames = readdir(DIR) or die "Unable to read current dir:$!\n";

  closedir(DIR);

  $filenames_ref = \@filenames;
  return ($filenames_ref);

}

sub read_bb_logs ($$$$) {
  my ($dummy, $DEBUG, $looking_for, $filenames_ref) = @_;
  my $found = "";
  my %hash_host_and_log = ();
  my $hash_host_and_log_ref;

  print "$0: DEBUG read_bb_logs DEBUG: $DEBUG, looking_for: '$looking_for', filenames_ref: '$filenames_ref'\n" if ($DEBUG);

  foreach my $log (@$filenames_ref) {
    print "$0: DEBUG looking_for: $looking_for\n" if ($DEBUG);
    next if ($log =~ /^\./); # if it starts with ".hostname" we are not interested

    if (-d $log){            # is this a directory?
      #print "found a directory: $name\n" if ($DEBUG);
      next;                  # can skip to the next name in the for loop
    }
        print "$0: DEBUG first log: '$log', looking_for: $looking_for\n" if ($DEBUG);

        next unless $log =~ /\.$looking_for$/i; # do not add an "o" to the end of this search

        print "$0: DEBUG looking_for: '$looking_for', log: '$log'\n" if ($DEBUG);

        my $host = $log;
        $host =~ s/\.$looking_for$//;
        $host =~ s/\,/\./g;

        print "$0: DEBUG LOG going to put into h_fn host: $host. log: $log\n" if ($DEBUG);

        $hash_host_and_log{$host}="$ENV{'BBLOGS'}/$log";
  }

  $hash_host_and_log_ref = \%hash_host_and_log;
  return ($hash_host_and_log_ref);

}

sub read_bb_data_logs ($$$$) {
  my ($dummy, $DEBUG, $looking_for, $filenames_ref) = @_;
  my $found = "";
  my %hash_host_and_log = ();
  my $hash_host_and_log_ref;

  print "$0: DEBUG read_bb_logs DEBUG: $DEBUG, looking_for: '$looking_for', filenames_ref: '$filenames_ref'\n" if ($DEBUG);

  foreach my $log (@$filenames_ref) {
    print "$0: DEBUG looking_for: $looking_for\n" if ($DEBUG);
    next if ($log =~ /^\./); # if it starts with ".hostname" we are not interested

    if (-d $log){            # is this a directory?
      #print "found a directory: $name\n" if ($DEBUG);
      next;                  # can skip to the next name in the for loop
    }
        print "$0: DEBUG first log: '$log', looking_for: $looking_for\n" if ($DEBUG);

        next unless $log =~ /\.$looking_for$/i; # do not add an "o" to the end of this search

        print "$0: DEBUG looking_for: '$looking_for', log: '$log'\n" if ($DEBUG);

        my $host = $log;
        $host =~ s/\.$looking_for$//;
        $host =~ s/\,/\./g;

        print "$0: DEBUG LOG going to put into h_fn host: $host. log: $log\n" if ($DEBUG);

        $hash_host_and_log{$host}="$ENV{'BBVAR'}/data/$log";
  }

  $hash_host_and_log_ref = \%hash_host_and_log;
  return ($hash_host_and_log_ref);

}


sub get_log_time ($$$){
  my ($dummy,$DEBUG,$log) = @_;
  my $ctime;
  # Sometimes you get it from stat, sometimes you get it from the log
  ($ctime) = (stat($log))[10];
  print "$0 : DEBUG ctime = $ctime\n" if ($DEBUG);
  return ($ctime);

}

sub get_info_from_log ($$$) {
  my ($dummy,$DEBUG,$log) = @_;
  my @log_data = ();
  my $log_data_ref;

  print "$0 : DEBUG in get_info_from_log  log=$log\n" if ($DEBUG);

  open(LOG,"$log");

    # Slurp up the log into an array
    @log_data = <LOG>;

  close(LOG);

  $log_data_ref = \@log_data;

  return ($log_data_ref);

}

sub update_rrd {

  my ($dummy, $DEBUG, $RRD, $update_time_for_log, $data_value, $reference_to_rrd_data_structure) = @_;
  my $rrdupdate;
  my $ERR;

  print "$0 : DEBUG in update_rrd RRD=$RRD\n" if ($DEBUG);

  # if it doesn't exist, make it
  if ( not -f $RRD ) {
                                           # Note that we need to pass a $dummy
                                           # variable since we are calling a
                                           # local sub
    &create_rrd($dummy,$DEBUG,$RRD,$reference_to_rrd_data_structure);
    return;
  }

  $rrdupdate = "$update_time_for_log:$data_value";

  print "$0 : DEBUG final update: $rrdupdate\n" if ($DEBUG);

  RRDs::update("$RRD","$rrdupdate");
  $ERR=RRDs::error;
  if($ERR) {
    print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
  }

}

sub create_rrd {

  my ($dummy,$DEBUG,$RRD,$reference_to_rrd_data_structure) = @_;
  my $ERR;
  my @rras;

  print "$0: DEBUG in create_rrd\n" if ($DEBUG);

    # RRAS defined in larrd.pl
    @rras = split " ",$ENV{'RRAS'};

    RRDs::create($RRD,@$reference_to_rrd_data_structure,@rras);
    $ERR=RRDs::error;
    if($ERR) {
      print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
    } else {
        print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
    }
    return;
}


END { }       # module clean-up code here (global destructor)

# Preloaded methods go here.

1;
__END__

=head1 NAME

LARRD - Perl extension for the Load Average RRD tool

=head1 SYNOPSIS

  use LARRD;
  my $larrd = new LARRD;
  $larrd->verbose(1);
  $larrd->verbose(0);
  $larrd->check_larrd-env;  # Confirm environment has been set
  $larrd->get_bb_log_filenames($DEBUG); # Returns a reference to a list of BB log filesnames
  $larrd->read_bb_logs($DEBUG,$ds,$filenames_ref); # Returns a reference to a hash of hosts with a passed data source type.
  $larrd->get_log_time($DEBUG,$log_filename); # Returns a time stamp for a log filename that is passed to it
  $larrd->get_info_from_log($DEBUG,$log_filename); # Returns a reference to the contents of a log file, stored in an array.
  

=head1 DESCRIPTION

First attempt at adding a perl module to LARRD.
Features are limited.


=head2 EXPORT

None by default.


=head1 AUTHOR

Craig Cook<lt>http://www.cookitservices.com<gt>

=head1 SEE ALSO

L<perl>.

=cut
