#!/usr/local/bin/perl
#
# $Id: memory-larrd.pl,v 1.3 2003/11/13 19:02:15 cncook Exp $
#
# memory-larrd.pl: larrd module memory
#
# Scott Walters Copyright 1999
# scott@PacketPushers.com 
#  
# Christian Pearce
# pearcec@PacketPushers.com
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# V1.0 Thomas Rucker
#
# V1.1 Craig Cook
#      added procedrues

# this is for after install
use lib $ENV{'RRDPM'};
#use lib "/usr/local/rrdtool/lib/perl/";
use RRDs;

use lib $ENV{'LARRDPM'};
#use lib "/usr/local/larrd/lib/LARRD";
use LARRD;

my $larrd = new LARRD;

##################################
# SETUP
##################################

# 1. Define the extention for the metric

$DS="DS:realmempct:GAUGE:600:0:U";
##################################
# Start of script
##################################

$larrd->check_larrd_env;

##
# real work begins here
##

# Glob the bind logs and data
my %h_fn;

# Perl Cookbook Recipe 9.5
# look for cpu-log and memory-log
# if both exist, use the memory-log, because
# cpu-log only has Real-Mem and no Swap-Mem
opendir(DIR, "$ENV{'BBLOGS'}") or die "$0: $!";
while ( defined($log = readdir(DIR))) {
        next unless $log =~ /\.cpu$/io or $log =~ /\.memory$/io;
        my @host = split(/\./,$log);
	if (!(defined($h_fn{"$host[0]"}))) {
		$h_fn{"$host[0]"}="$host[1]";
	}
	elsif (($h_fn{"$host[0]"} eq "cpu") && ($host[1] eq "memory")) {
		$h_fn{"$host[0]"}="$host[1]";
	}
}
closedir(DIR);


foreach $host (keys %h_fn) {
        print "$0 : DEBUG host=$host\n" if ($ENV{'DEBUG'});

	my $log = $host;
	$log = "$ENV{'BBLOGS'}/$log";
	$log .= ".$h_fn{$host}";

	print "$0 : DEBUG log=$log\n" if ($ENV{'DEBUG'});

	open(LOG,"$log");
        my @temp = <LOG> if $log =~ /$ENV{'BBLOGS'}/io;
	close(LOG);

###
### grab data, check if data is from .cpu or from .memory (Windows Memory Plugin)
###
	if ($log=~/\.cpu$/) {
		print "$0 : DEBUG using $host.cpu\n" if ($ENV{'DEBUG'});
		$REALMEM=$temp[0];
		$SWAPMEM=0;
		$REALMEM=~s/.*\(//;
		$REALMEM=~s/%\).*//;
	} else {
		print "$0 : DEBUG using $host.memory\n" if ($ENV{'DEBUG'});
		foreach $logline (@temp) {
			if ( $logline=~/Physical/ ) { $REALMEM=$logline; }
			elsif ( $logline=~/Swap|Page/ ) { $SWAPMEM=$logline; }
		}
		$REALMEM=(split(" ",$REALMEM))[4];
		$REALMEM=~s/\%//;
		$SWAPMEM=(split(" ",$SWAPMEM))[4];
		$SWAPMEM=~s/\%//;
	}

###
### grab the timpstamp for rrd. 
###

        &get_log_time;

###
### create REAL-RRD if not exist and update data
###
        $RRD="$ENV{'BBRRDS'}/$host.memory.real.rrd";
        print "$0 : DEBUG RRD=$RRD\n" if ($ENV{'DEBUG'});
	# see if the RRD is around, if not make it	
	if ( not -f $RRD ) {
		&create_rrd;
	}
	print "$0 : DEBUG REAL=$REALMEM\n" if ($ENV{'DEBUG'});
	RRDs::update("$RRD","$ctime:$REALMEM");
	$ERR=RRDs::error;
        if($ERR) {
                print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'})
;
        }

###
### create SWAP-RRD if not exist and update data
###
        $RRD="$ENV{'BBRRDS'}/$host.memory.swap.rrd";
        print "$0 : DEBUG RRD=$RRD\n" if ($ENV{'DEBUG'});
	# see if the RRD is around, if not make it	
	if ( not -f $RRD ) {
		&create_rrd;
	}
	print "$0 : DEBUG SWAP=$SWAPMEM\n" if ($ENV{'DEBUG'});
	RRDs::update("$RRD","$ctime:$SWAPMEM");
	$ERR=RRDs::error;
        if($ERR) {
                print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'})
;
        }
        unlink $log if $ENV{'LARRDCOMM'} =~ /DATA/i;

}	

sub get_log_time {
  # Sometimes you get it from stat, sometimes you get it from the log
  ($ctime) = (stat($log))[10];
  print "$0 : DEBUG ctime = $ctime\n" if ($DEBUG);
}

sub create_rrd {

  print "$0: DEBUG in create_rrd\n" if $DEBUG;

    # RRAS defined in larrd.pl
    @rras = split " ",$ENV{'RRAS'};

    RRDs::create($RRD,@ds,@rras);
    $ERR=RRDs::error;
    if($ERR) {
      print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
      next;
    }

    $ctime="N";
    print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
}

##############################################
# end of script
##############################################
