#!/usr/local/bin/perl
#
# $Id: socks-larrd.pl,v 1.4 2004/01/20 19:12:02 cncook Exp $
#
# socks-larrd.pl - larrd module for collecting socks stats 
#
# Craig Cook 13 Mar 2003
# Removed incorrect DEBUG line
# Created @ds
# Created $ds
#
# 27 Jun 2003   Craig Cook
# Changed status check to look for colour status only at start of line
#
# Do whatever you want with it
# just don't sell it and make money off of it and not cut me in ;)
# I take no liability for it, use at your own risks

# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
#use lib "/usr/local/rrdtool/lib/perl/";
use RRDs;

use lib $ENV{'LARRDPM'};
#use lib "/usr/local/larrd/lib/LARRD";
use LARRD;

my $larrd = new LARRD;

$ds = "socks";

@ds = ("DS:socks:GAUGE:600:0:U"
       );

##################################
# Start of script
##################################

$larrd->check_larrd_env;

##
# real work begins here
##

# go to the logs area for simplication of the list
chdir "$ENV{'BBLOGS'}";

# Glob the logs
LOG: while (  defined ($log = <*.$ds>)  ) {

        $host=$log;
        # create some handy vars
        $host =~ s/\.$ds//;
        $host =~ s/\,/\./g;

        ($ctime) = (stat($log))[10];

	# Grab Load Avg line
        open(LOG,"$log");
	$line=<LOG>;

	if($line !~ /^green\s+|^yellow\s+|^red\s+/) {
		print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($ENV{'WARN'});
		next LOG;
	}
        chomp($line=<LOG>);
	close(LOG);

	$line =~ /(\d+)/;
	$socks = $1;	

	
	# RRD for socks
	
	$RRD="$ENV{'BBRRDS'}/$host.socks.rrd";

	# if it doesn't exist, make it 
	if ( not -f $RRD ) {
			# RRAS defined in larrd.pl
			@rras = split " ",$ENV{'RRAS'};
			RRDs::create($RRD,@ds,@rras);
                        $ERR=RRDs::error;
                        if($ERR) {
                                print "$0: ERROR creating $RRD: $ERR\n" if ($ENV{'ERROR'});
				next;
                        }
		$ctime="N";
		print "$0: STATUS did not find $RRD, created.\n" if ($ENV{'STATUS'});
	}

	RRDs::update("$RRD","$ctime:$socks");
        $ERR=RRDs::error;
        if($ERR) {
 	       print "$0: WARN updating $RRD: $ERR\n" if ($ENV{'WARN'});
        }

	# Sloppy
        ($ctime) = (stat($log))[10];

        unlink $log if $log =~ /$ENV{'BBVAR'}\/data/io;

}

##############################################
# end of script
##############################################
