#!/usr/local/bin/perl
#
# $Id: template-larrd.pl,v 1.3 2003/03/18 21:55:16 cncook Exp $
#
# Do whatever you want with it, just don't sell it!
# I take no liability for it, use at your own risk!

# V1.0 17 Feb 2005    Craig Cook
#

my $DEBUG = 0;
$DEBUG = 1 if $ENV{'DEBUG'};

if ($DEBUG) {
  $WARN = 1;
  use Data::Dumper;
  $ENV{'BBHOME'}="/usr/local/bb";
  $ENV{'BBVAR'}="/usr/local/bbvar";
  $ENV{'BBLOGS'}="/usr/local/bbvar/logs";
  $ENV{'BBRRDS'}="$ENV{'BBVAR'}/rrd";
  use lib "/usr/local/rrdtool/lib/perl/";
  use lib "/usr/local/larrd/lib/LARRD";
}


# Set a path to the rrd tool lib
# Set as and $ENV and see what is up
use lib $ENV{'RRDPM'};
use RRDs;

use lib $ENV{'LARRDPM'};
use LARRD;

my $larrd = new LARRD;

# 1. Define the extention for the metric

$ds = "extention";
@ds = ("DS:METRIC1:COUNTER:600:U:U",
       "DS:METRIC2:GAUGE:600:1:U");

my $reference_to_rrd_data_structure = \@ds;
my $RRD;

##################################
# Start of script
##################################

$larrd->check_larrd_env;

##
# real work begins here
##

$filenames_ref = $larrd->get_bb_log_filenames($DEBUG);

$hash_ref_for_hosts = $larrd->read_bb_logs($DEBUG,$ds,$filenames_ref);

while ( ($host,$log_filename) = each %$hash_ref_for_hosts ) {

    $RRD="$ENV{'BBRRDS'}/$host.$ds.rrd";

    print "$0 : DEBUG host=$host, log=$log_filename\n" if ($DEBUG);

    $log_time = $larrd->get_log_time($DEBUG,$log_filename);

    $reference_to_log_data = $larrd->get_info_from_log($DEBUG,$log_filename);

    if($$reference_to_log_data[0] !~ /^(green|yellow|red)\s+/) {
            print "$0: WARN $host is not showing red, yellow, or green. $log skipped.\n" if ($WARN);
            next;
    }

    # Now lets process the data

    my $data_value = &process_log($DEBUG,$reference_to_log_data);

    if ($data_value ne "") {

       # If we are looking at a log with no larrdable data
       # do not create the rrd and in turn the graph
       # It makes sense this way.

       $larrd->update_rrd($DEBUG,$RRD,$log_time,$data_value,$reference_to_rrd_data_structure);

    } # end if ($data_value ne "") {


}

sub process_log ($$) {
my $DEBUG = shift;
my $log_data_ref = shift;
my $data_value = undef;

  print "$0: DEBUG in process_log\n" if $DEBUG;

  foreach $line (@$log_data_ref) {

    print "$0: DEBUG line: $line\n" if $DEBUG;

    #Expect data like this:

    # some number 45 data we want

    next unless $line =~ /data we want:/;
    if ( $line =~ /(\d+) data we want ) {
      $data_value = $1;
    }

    if (defined ($data_value)) {
      $data_value = $data_value; (<--- do whatever you want to mess with it here);
    }

    print "$0: DEBUG Data Value: $data_value\n" if $DEBUG;

    return $data_value;

  }
}

##############################################
# end of script
##############################################
